 
-- many functions here were taken from Plot.hs in http://gregheartsfield.com/repos/fractal-hs/

module Plot (Pos, Window, plot) where
import Graphics.GD
import Data.Time

type Pos = (Double, Double)
type Window = (Pos, Pos)

-- image pixel -> viewing window -> size -> a complex point
pixelToPos :: Point -> Window -> Size -> Pos
pixelToPos (px,py) ( (left, top) , (right, bot) ) (width, height) =
       ( (left + (right-left)*x) , (bot + (top-bot)*y) )
    where x = fromIntegral px / fromIntegral width
          y = fromIntegral py / fromIntegral height
 

-- Graphics.GD functions:
-- setPixel :: Point -> Color -> Image -> IO ()
-- newImage :: Size -> IO Image

plot :: (Pos -> Color) -> Size -> Window -> String -> IO ()
plot posToColor size window name =
    do img <- newImage size
       time <- ((read <$> formatTime defaultTimeLocale "%S" <$> getCurrentTime) :: IO Int)
       mapM_ (\p -> setPixel p (posToColor (pixelToPos p window size)) img) $ allPixels size
                
   --    img2 <- newImage (600,600)
 --      copyRegionScaled (0,0) (100,100) img (120,5) (300,300) img2
   --    tm <- (fmap show getZonedTime)
       savePngFile (name ++ "_" ++ (show time)) img
  --     savePngFile (name ++ "__" ++ (show time)) img2

-- List of all pixels in a window of size (w,h)
allPixels :: Size -> [Point]
allPixels (w,h) = [(x,y) | x <- [0..(w-1)], y <- [0..(h-1)]]




